package Controll;

import Modules.Module;
import net.dv8tion.jda.api.EmbedBuilder;
import net.dv8tion.jda.api.events.GenericEvent;
import net.dv8tion.jda.api.events.guild.GenericGuildEvent;
import net.dv8tion.jda.api.events.message.guild.GuildMessageReceivedEvent;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class Help extends SuperModule {

    public final Logger logger = LoggerFactory.getLogger(Help.class);
    public static final String command = "help";

    public Help( GuildController guildController){
        super(command, guildController, null);
    }

    @Override
    public String getCommand() {
        return command;
    }

    @Override
    public String getDescription() {
        return "shows this message";
    }

    @Override
    public void execute(GenericEvent genericEvent) {

        if (!(genericEvent instanceof GenericGuildEvent))
            return;

        GenericGuildEvent event = (GenericGuildEvent) genericEvent;

        if (event instanceof GuildMessageReceivedEvent){

            GuildMessageReceivedEvent thisEvent = (GuildMessageReceivedEvent) event;

            if (!isCommand(thisEvent.getMessage()))
                return;

            logger.debug(command + "triggered");

            EmbedBuilder eb = new EmbedBuilder()
                    .setAuthor("Hiajen#9880", "https://www.hiajen.de")
                    .setTitle("BOT by Hiajen#9880");

            for (Module x : getGuildController().getModuleList()){
                eb.addField(x.getCommand(), x.getDescription(), false);
            }

            thisEvent.getChannel().sendMessage(eb.build()).queue();
        }
    }

    @Override
    public String showSettings() {
        return null;
    }
}
